library Expander;
uses
  SysUtils,Windows, Classes,Inifiles;

{$E wdx}
const
    ft_nomorefields=0;
    ft_numeric_32=1;
    ft_numeric_64=2;
    ft_numeric_floating=3;
    ft_date=4;
    ft_time=5;
    ft_boolean=6;
    ft_multiplechoice=7;
    ft_string=8;
    ft_fulltext=9;
    ft_datetime=10;
    //For ContentGetValue
    ft_nosuchfield=-1;
    ft_fileerror=-2;
    ft_fieldempty=-3;
    ft_ondemand=-4;
    ft_delayed=0;
    CONTENT_DELAYIFSLOW=1;  // ContentGetValue called in foreground


    //For the plugin 
    ListeElement:array[0..9]of PChar =('Part1','Part2','Part3','Part4','Part5','Part6','Part7','Part8','Part9','Part10'); //List of the element we'll be abble to show
    fieldcount:integer=10; //Number of field

{------------------------------------------------------------------------------}
function ContentGetSupportedField(FieldIndex:integer;FieldName:pchar;Units:pchar;maxlen:integer):integer; stdcall;
begin
    result:=0;
    if ((FieldIndex<0) OR (FieldIndex>fieldcount-1)) then Result:=ft_nomorefields;
    if ((FieldIndex>=0) AND (FieldIndex<fieldcount)) then
    begin
        StrCopy(Units,''); //If we do not need any sub-menu, otherwise it has to be specify (see help file)
        StrCopy(FieldName,ListeElement[FieldIndex]); // "Telling" to TC what field we will show :) (it's define above)
        Result:=ft_string;
    end;
end;

{------------------------------------------------------------------------------}
procedure Split(const Delimiter: Char;Input: string;const Strings: TStrings);
begin
  Assert(Assigned(Strings));
  Strings.Clear;
  Strings.Delimiter := Delimiter;
  Strings.DelimitedText := Input;
end;
{------------------------------------------------------------------------------}
function ContentGetValue(FileName:pchar;FieldIndex,UnitIndex:integer;FieldValue:pbyte;maxlen,flags:integer):integer; stdcall;
var
    s,sep:string;
    divi:array[0..2]of char;
    path:string;
    tmpIni:TIniFile;
    ModName: array[0..259] of Char;
    List:Tstringlist;
begin

    divi[0]:=#0;

    divi[1]:=#0;

    SetString(path, ModName,Windows.GetModuleFileName(HInstance, ModName, SizeOf(ModName)));

    path:=ExtractFilePath(path)+'Expander.lng';
    tmpIni:=TIniFile.create(path);

    sep:=tmpIni.ReadString('Main','Divider','_');

    strlcat(divi,pchar(sep),sizeof(divi)-1);

    result:=ft_fileerror;

    if((FieldIndex>-1) AND (FieldIndex<fieldcount)) then

    begin
        if (divi[0]='\') then s:=FileName
        else s:=ExtractFileName(FileName);
        //MessageBox(GetActiveWindow,pchar(path),'',MB_OK);
        s:=StringReplace(s,' ','#A#',[rfReplaceAll, rfIgnoreCase]);
        List:=TStringList.create;
        Split(divi[0],s,List);
        if List.count-1 < FieldIndex then begin
           result:=ft_fieldempty;
        end else begin
           List[FieldIndex]:=StringReplace(List[FieldIndex],'#A#',' ',[rfReplaceAll, rfIgnoreCase]);
           StrCopy(PChar(FieldValue),PChar(List[FieldIndex]));
           result:=ft_string;
           List.Free;
        end;
    end;
end;
{------------------------------------------------------------------------------}

exports
    ContentGetValue,
    ContentGetSupportedField;
{------------------------------------------------------------------------------}
end.




